SystemOrganization addCategory: #MareaMocks!

!CompiledMethodProxyReferenceStream methodsFor: '*MareaMocks' stamp: 'MarianoMartinezPeck 10/22/2010 11:21'!
fooSomething
	^ 'fooSomethingProxy'! !

!ObjectProxy methodsFor: '*MareaMocks' stamp: 'MarianoMartinezPeck 10/17/2010 19:13'!
fooSomething
	^ 'fooSomethingProxy'! !

ProtoObject subclass: #ClassWithRunWithIn
	instanceVariableNames: 'oldMethod reference executed'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MareaMocks'!

!ClassWithRunWithIn classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
installOn: aClass selector: aSel
	| newInst |
	newInst := (self on: aClass selector: aSel)  install.
	^ newInst! !

!ClassWithRunWithIn classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
installOnClass: aClass
	|someWrappers|
	someWrappers:=OrderedCollection new.
	aClass selectors do: [:aSymbol | someWrappers add: (self installOn: aClass selector: aSymbol)].
	aClass class selectors do: [:aSymbol | someWrappers add: (self installOn: aClass class selector: aSymbol)].
	^someWrappers! !

!ClassWithRunWithIn classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
installOnClassCategory: aString
	|someWrappers|
	someWrappers:= OrderedCollection new.
	(Smalltalk organization listAtCategoryNamed: aString) do: [:aClassName | 
		someWrappers addAll: (self installOnClass: (Smalltalk classNamed: aClassName)).
		].
	^someWrappers
	! !

!ClassWithRunWithIn classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
on: aMethodReference
	^self new initializeFor: aMethodReference ! !

!ClassWithRunWithIn classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
on: aClass selector: aSelector
	^self on: (MethodReference class: aClass selector: aSelector)! !

!ClassWithRunWithIn classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
uninstallClass: aClass
	aClass methodDict values do: [:e | (e isKindOf: self) ifTrue: [e uninstall]].
	aClass class methodDict values do: [:e | (e isKindOf: self) ifTrue: [e uninstall]].! !

!ClassWithRunWithIn classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
uninstallClassCategory: aString
	(Smalltalk organization listAtCategoryNamed: aString) do: [:aClassName | 
		self uninstallClass: (Smalltalk classNamed: aClassName)]! !

!ClassWithRunWithIn classSide methodsFor: 'instance creation' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
uninstallOnClassCategory: aString
	(Smalltalk organization listAtCategoryNamed: aString) do: [:aClassName | 
		self uninstallClass: (Smalltalk classNamed: aClassName)]! !

!ClassWithRunWithIn methodsFor: 'testing' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
doesNotUnderstand: aMessage
	self log: ' CompiledMethodProxy dnu: ', aMessage asString.
	^ oldMethod isNil
		ifTrue: [
			"It was not installed"
			super doesNotUnderstand: aMessage]
		ifFalse: [
			"It was installed, thus, I should uninstall it"
			self uninstall.
			oldMethod perform: aMessage selector withArguments: aMessage arguments.
			]! !

!ClassWithRunWithIn methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
executed
	^ executed! !

!ClassWithRunWithIn methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
executed: anObject
	executed := anObject! !

!ClassWithRunWithIn methodsFor: 'action' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
flushCache
	"This method should be implemented because otherwise there are errors."! !

!ClassWithRunWithIn methodsFor: 'initializing' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
initialize

	super initialize.
	executed := false! !

!ClassWithRunWithIn methodsFor: 'initializing' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
initializeFor: aMethodReference 
	reference := aMethodReference.! !

!ClassWithRunWithIn methodsFor: 'action' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
install
	[oldMethod := self wrappedClass lookupSelector: self selector.
	oldMethod isKindOf: self class] whileTrue: [oldMethod uninstall].
	"self wrappedClass addSelector: self selector withMethod: self" 
	self log: 'The method ', self selector asString, ' is being wrapped'.
	self wrappedClass methodDict at: self selector put: self! !

!ClassWithRunWithIn methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
oldMethod
	"Answer the value of oldMethod"

	^ oldMethod! !

!ClassWithRunWithIn methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
oldMethod: anObject
	"Set the value of oldMethod"

	oldMethod := anObject! !

!ClassWithRunWithIn methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
reference
	^ reference ! !

!ClassWithRunWithIn methodsFor: 'action' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
run: aSelector with: arguments in: aReceiver

	| aResult |
	self log: 'The method ', aSelector asString, ' is being executed'.
	aResult := oldMethod valueWithReceiver: aReceiver arguments: arguments.
	self executed: true.
	self log: 'The method', aSelector asString, ' was executed'.
	self uninstall.
	self log: 'The method proxy was uninstalled'.
	^aResult
	! !

!ClassWithRunWithIn methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
selector
	"Answer the value of selector"

	^ reference selector! !

!ClassWithRunWithIn methodsFor: 'action' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
uninstall
	oldMethod isNil ifTrue: [^self].
	self wrappedClass methodDict at: self selector put: oldMethod  

! !

!ClassWithRunWithIn methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/22/2010 11:40'!
wrappedClass
	"Answer the value of wrappedClass"

	^ reference actualClass! !

Object subclass: #ClassWith1Var
	instanceVariableNames: 'var1'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MareaMocks'!

!ClassWith1Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/2/2010 19:26'!
foo
	^ 'foo'! !

!ClassWith1Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/18/2010 16:30'!
foo2
	^ 'foo2'! !

!ClassWith1Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/19/2010 23:07'!
foo: something
	^ 'foo'! !

!ClassWith1Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/20/2010 11:21'!
fooDNU
	self unExistentMethod! !

!ClassWith1Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/17/2010 19:13'!
fooSomething
	^ 'fooSomething'! !

!ClassWith1Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 9/29/2010 15:30'!
var1
	^ var1! !

!ClassWith1Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 9/29/2010 15:30'!
var1: anObject
	var1 := anObject! !

Object subclass: #ClassWith2Var
	instanceVariableNames: 'var1 var2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MareaMocks'!

!ClassWith2Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/16/2010 21:30'!
foo
	^ 'foo'! !

!ClassWith2Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/16/2010 21:30'!
var1
	^ var1! !

!ClassWith2Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/16/2010 21:30'!
var1: anObject
	var1 := anObject! !

!ClassWith2Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/16/2010 21:31'!
var2
	^ var2! !

!ClassWith2Var methodsFor: 'accessing' stamp: 'MarianoMartinezPeck 10/16/2010 21:31'!
var2: anObject
	var2 := anObject! !

Object subclass: #ClassWithDNU
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'MareaMocks'!

!ClassWithDNU methodsFor: 'as yet unclassified' stamp: 'MarianoMartinezPeck 10/21/2010 16:02'!
doesNotUnderstand: aMessage
	^ 'dnu'! !

!Object methodsFor: '*MareaMocks' stamp: 'MarianoMartinezPeck 10/7/2010 18:15'!
fooObject! !
